<?php

// this file can be run from a web browser or command line.

// you need to manually create the reports/ directory
// and a reports/raw/ directory.

// argspy will produce a log file for every day it is called on.
// concatentate these log files into a single file for the week or month.
// location of that file.
$argfile = "$DOCUMENT_ROOT"."access.log";

// directory where html reports will be stored
$reports = "$DOCUMENT_ROOT"."arg/reports";

// hostname of your site
$site = "hostname";

// if arglogs.php is run on a machine located in a different timezone
// then set timeshift to the difference in time.
$timeshift = 0;

// chop URLs that exceed this value
$display_length = 60;

//////////////////////////////////////////////////////////////////////////////////

function get_os($info){
	if(stristr($info, "Win")) return "Windows";
	if(stristr($info, "Linux")) return "Linux";
	if(stristr($info, "FreeBSD")) return "FreeBSD";
	if(stristr($info, "Macintosh")) return "MacOS";
	if(stristr($info, "Mac_PowerPC")) return "MacOS";
	return "Unknown";
}
function get_browser2($info){
	if(stristr($info, "MSIE")) return "IE";
	if(stristr($info, "Opera")) return "Opera";
	if(stristr($info, "MuscatFerret")) return "MuscatFerret";
	if(stristr($info, "NetMind")) return "NetMind";
	if(stristr($info, "Mozilla")) return "Mozilla";
	if(stristr($info, "ZyBorg")) return "ZyBorg";
	return "Unknown";
}
function addtolist($list, $item, $count){
	for($i=0; $i<sizeof($list); $i++){
		if($list[$i][0] == $item){
			$list[$i][1] += $count;
			return $list;
		}
	}
	$array = explode(" :^: ", "$item :^: $count");
	$list[] = $array;
	return $list;
}
function addtolist2($list, $item1, $item2){
	for($i=0; $i<sizeof($list); $i++){
		if($list[$i][0] == $item1 && $list[$i][1] == $item2) return $list;
	}
	$array = explode(" :^: ", "$item1 :^: $item2");
	$list[] = $array;
	return $list;
}
function displaybar($percentage){
	global $fout;

	$line = $line ."<font color=#ff0000>";
	for($i=0; $i < $percentage; $i++) $line = $line ."|";
	$line = $line ."</font> ($percentage%)";
	return $line;
}
function displaylist($name, $list){
	global $totalhits, $fout;

	fwrite($fout, "<p><hr><p><b>$name:</b><ul type=none><li><table border=0>");
	for($i=0; $i<sizeof($list); $i++){
		$hits = $list[$i][1];
		fwrite($fout, "<tr><td align=right>". $list[$i][0] .
		"&nbsp;</td><td>&nbsp;");
		fwrite($fout, displaybar(ceil(($hits/$totalhits)*100)));
		fwrite($fout, "&nbsp;&nbsp;<b>$hits</b></td></tr>");
	}
	fwrite($fout, "</table></ul>");
}
function displaylist2($name){
	global $dir_hits, $dir_bad_hits, $dir_host_hits, $totalhits, $fout;

	fwrite($fout, "<p><hr><p><b>$name:</b> (<b>total</b>, <font color=#ff0000>errors</font>, unique)<ul type=none><li><table border=0>");
	$err = "";
	for($i=0; $i<sizeof($dir_hits); $i++){
		$hits = $dir_hits[$i][1];
		$bad = 0;
		for($j=0; $j<sizeof($dir_bad_hits); $j++){
			if($dir_bad_hits[$j][0] == $dir_hits[$i][0]){ $bad = $dir_bad_hits[$j][1]; break; }
		}
		$uniq = 0;
		for($j=0; $j<sizeof($dir_host_hits); $j++){
			if($dir_host_hits[$j][0] == $dir_hits[$i][0]){ $uniq = $dir_host_hits[$j][1]; break; }
		}
		if($hits == $bad) $errors = 1;
		else $errors = 0;
		$line = "<tr><td align=right>". $dir_hits[$i][0] ."&nbsp;</td><td>&nbsp;";
		$line = $line . displaybar(ceil(($hits/$totalhits)*100));
		if($errors) $line = $line ."&nbsp;&nbsp;<font color=#ff0000>$bad</font>, $uniq</td></tr>";
		else $line = $line ."&nbsp;&nbsp;<b>$hits</b>, <font color=#ff0000>$bad</font>, $uniq</td></tr>";
		if(!$errors) fwrite($fout, $line);
		else $err = $err . $line;
	}
	if(!empty($err)) fwrite($fout, "<tr><td></td><td>----------</td></tr>$err</table></ul>");
	else fwrite($fout, "</table></ul>");
}
function hitsort($a, $b){
	if($a[1] == $b[1]) return 0;
	return ($a[1] > $b[1]) ? -1 : 1;
}

//////////////////////////////////////////////////////////////////////////////////

	if(!$fp=fopen($argfile, "r")){
		echo "<p align=center>Unable to open access log file.";
		exit();
	}

	do{
		$entry = fgets($fp, 1024); $entry = substr($entry, 0, strlen($entry)-1);
		if(!empty($entry)){
			$entry_ar = explode(" :: ", $entry);
			$entry_ar[0] += $timeshift;
			$access[] = $entry_ar;
		}
	} while(!empty($entry));
	fclose($fp);

//////////////////////////////////////////////////////////////////////////////////

$arg2name = strftime("%Y-%m-%d", $access[0][0]);

if(!copy("$argfile", "$reports/raw/log.$arg2name")){
	echo "<p align=center>Unable to copy access log file to $reports/raw/.";
}
chmod("$reports/raw/log.$arg2name", 0664);

if(!$out2=fopen("$reports/temp.html", "w")){
	echo "<p align=center>Unable to open $reports/temp.html file for writing.";
	exit();
}

if(!$fout=fopen("$reports/$arg2name.html", "w")){
	echo "<p align=center>Unable to open $reports/$arg2name.html file for writing.";
	fclose($out2);
	exit();
}

echo "<p align=center>Created file $reports/$arg2name.html";

//////////////////////////////////////////////////////////////////////////////////

	$hits404 = 0; $hits200 = 0;
	$totalhits = sizeof($access);

	for($e = 0; $e < $totalhits; $e++){
		set_time_limit(30);

		$info = $access[$e][3];


		// daily hits
		$daily_hits = addtolist($daily_hits, strftime("%A", $access[$e][0]), 1);


		// hourly hits
		$hourly_hits = addtolist($hourly_hits, strftime("%H:00-%H:59", $access[$e][0]), 1);


		// total unique hits
		$host = $access[$e][2];
		if($host == ".") $host = $access[$e][1];
		if(strlen($host) > $display_length) $dl = strlen($host) - $display_length;
		else $dl = 0;
		$host_hits = addtolist($host_hits, substr($host, $dl, strlen($host)), 1);


		// referals
		$referal = $access[$e][4];
		if($referal == ".") $referal = "";
		else {
			$referal = " <a href=\"$referal\">". substr($referal, 0, $display_length) ."</a>";
			$referal_hits = addtolist($referal_hits, $referal, 1);
			$referal = "$referal <b>--&gt;</b>";
		}


		// total good/bad hits
		$status = $access[$e][10];
		if($status == "."){ $status = ""; $hits200++; }
		else if($status != 200){ $status = "<font color=#bf0000>$status "; $hits404++; }
		else { $status = ""; $hits200++; }


		// page hits
		$page = $access[$e][6];
		$page_hits = addtolist($page_hits, substr($page, 0, $display_length), 1);


		// directory hits: total, good, bad and unique
		$s = 0;
		for($x=1; $x < strlen($page); $x++) if($page[$x] == '/'){ $s = $x; $x = strlen($page); }
		if(empty($s)) $s = 1;
		$dir = substr($page, 0, $s);
		if($dir == "/x"){
			for($x=$s+1; $x < strlen($page); $x++){
				if($page[$x] == '/'){ $s = $x; $x = strlen($page); }
			}
			if(empty($s)) $s = 1;
			$dir = substr($page, 0, $s);
		}
		$da[] = $dir; $da[] = $host;
		if(empty($status)) $da[] = 1;
		else $da[] = 0;
		$dir_array[] = $da;
		$da = "";

		// browser hits
		$browser = get_browser2($info);
		$browser_hits = addtolist($browser_hits, $browser, 1);


		// os hits
		$os = get_os($info);
		$os_hits = addtolist($os_hits, $os, 1);


		// output raw html listing
		$time = strftime("<b>%H:%M %d%b%Y</b>", $access[$e][0]);
		$a = "$time $status$os / $browser <b>$host</b>$referal";
		fputs($out2, "$a <a href=\"$page\"><b>$page</b></a>$endstatus\n");
		if(!empty($status)) fputs($out2, "</font>");
	}
	fclose($out2);


	// directory hits
	sort($dir_array);
	for($i=0; $i < sizeof($dir_array); $i++){
		set_time_limit(30);
		$dir = $dir_array[$i][0];
		$host = $dir_array[$i][1];

		$dir_hits = addtolist($dir_hits, $dir, 1);

		if(!$dir_array[$i][2]) $dir_bad_hits = addtolist($dir_bad_hits, $dir, 1);

		$dir_host_hits2 = addtolist2($dir_host_hits2, $dir, $host);
		
	}
	set_time_limit(30);
	for($i=0; $i < sizeof($dir_host_hits2); $i++){
		$dir_host_hits = addtolist($dir_host_hits, $dir_host_hits2[$i][0], 1);
	}

//////////////////////////////////////////////////////////////////////////////////

	set_time_limit(30);
	sort($hourly_hits);
	usort($browser_hits, hitsort);
	usort($os_hits, hitsort);
	usort($dir_hits, hitsort);

	set_time_limit(30);
	usort($page_hits, hitsort);

	set_time_limit(30);
	usort($host_hits, hitsort);

	set_time_limit(30);
	usort($referal_hits, hitsort);

//////////////////////////////////////////////////////////////////////////////////

	set_time_limit(30);
	fwrite($fout, "<head><title>phpARG v1.0</title></head><body><p align=center>$site<hr>");

	$start = $access[0][0];
	$end = $access[$totalhits-1][0];
	$run = $end - $start;
	if($run < 86400) $run = round(($run / 3600) * 100) / 100 ." hours";
	else $run = round(($run / 86400) * 100) / 100 . " days";

	fwrite($fout, "<p>Start time: <b>". strftime("%H:%M %d%b%Y", $start) ."</b> , End time: <b>".
	strftime("%H:%M %d%b%Y", $end) ."</b> , Running time: <b>$run</b>");

	fwrite($fout, "<p>Total hits: <b>$totalhits</b><br>".
	"Successful Hits: <b>$hits200</b><br>".
	"Errors: <b>$hits404</b><br>".
	"Unique Directories: <b>". sizeof($dir_hits) . "</b><br>".
	"Unique Hosts: <b>". sizeof($host_hits) . "</b><br>".
	"Unique Pages: <b>". sizeof($page_hits) . "</b><br>".
	"Unique Referals: <b>". sizeof($referal_hits) . "</b><br>".
	"Unique Browsers: <b>". sizeof($browser_hits) . "</b><br>".
	"Unique OSes: <b>". sizeof($os_hits) . "</b>");

	fwrite($fout, "<p>| <a href=\"#daily\">Daily</a> | <a href=\"#hourly\">Hourly</a> | ".
	"<a href=\"#browsers\">Browsers</a> | <a href=\"#oses\">OSes</a> | ".
	"<a href=\"#dirs\">Directories</a> | ".
	"<a href=\"#hosts\">Hosts</a> | <a href=\"#pages\">Pages</a> | ".
	"<a href=\"#referals\">Rerferals</a> | <a href=\"#raw\">Raw</a> |");

	set_time_limit(30);
	fwrite($fout, "<a name=\"daily\"></a>"); displaylist("Hits per day", $daily_hits);
	fwrite($fout, "<a name=\"hourly\"></a>"); displaylist("Hits per hour", $hourly_hits);
	fwrite($fout, "<a name=\"browsers\"></a>"); displaylist("Browsers", $browser_hits);
	fwrite($fout, "<a name=\"oses\"></a>"); displaylist("OSes", $os_hits);
	set_time_limit(30);
	fwrite($fout, "<a name=\"dirs\"></a>"); displaylist2("Directories");
	set_time_limit(30);
	fwrite($fout, "<a name=\"hosts\"></a>"); displaylist("Hosts", $host_hits);
	set_time_limit(30);
	fwrite($fout, "<a name=\"pages\"></a>"); displaylist("Pages", $page_hits);
	set_time_limit(30);
	fwrite($fout, "<a name=\"referals\"></a>"); displaylist("Referals", $referal_hits);

	set_time_limit(30);
	fwrite($fout, "<a name=\"raw\"></a><p><hr><pre>\n");

	if(!$fin=fopen("$reports/temp.html", "r")){
		echo "<p align=center>Unable to open temp.html file for reading.";
		fwrite($fout, "<p align=center>Unable to open temp.html file for reading.");
	} else {
		for($i=0; !feof($fin); $i++) fwrite($fout, fgets($fin, 1024));
		fclose($fin);
	}

	fwrite($fout, "</pre>");

	fwrite($fout, "<p><hr><p align=right><a href=\"http://www.qzx.com/phpARG\">phpARG v1.0</a>".
	" Copyright &copy; 2001 Brand Huntsman");

	fclose($fout);

//////////////////////////////////////////////////////////////////////////////////

unlink("$reports/temp.html");
